package org.edg.wl.dgas.dgassim.workload.pa;

import org.edg.wl.dgas.dgassim.*;
import org.edg.wl.dgas.dgassim.fabric.*;

public class HybridPricingModule implements PricingModule {

    private boolean verbose;
    private boolean debug;

    private int BASE_PRICE, DELTA_P;

    public HybridPricingModule(int basePrice, int deltaP,
			       boolean verbose, boolean debug) {

	BASE_PRICE = basePrice;
	DELTA_P = deltaP;

	this.verbose = verbose;
	this.debug = debug;

	if (debug)
	    System.out.println("constructor of class HybridPricingModule");

	if (debug)
	    System.out.println("BASE_PRICE="+BASE_PRICE
			       +", DELTA_P="+DELTA_P);

    }


    public int computePrice(ComputingElement ce) {

	double cQWT = (double) ce.getCurrQWT();
	double mQWT = (double) ce.getMaxQWT();

	int price = (int) (BASE_PRICE +
			   DELTA_P*( (cQWT - mQWT/2) / (mQWT/2) ) );

	if (debug)
	    System.out.println("[HybridPricingModule] ceID="+ce.getId()
			       +", cQWT="+cQWT+", mQWT="
			       +mQWT+" => new price is "+price);

	return price;
    }

}
