package org.edg.wl.dgas.dgassim.workload.rb;

import java.util.*;
import org.edg.wl.dgas.dgassim.*;
import org.edg.wl.dgas.dgassim.fabric.*;

public class PriceSensitiveUtilityModule implements UtilityModule {

    public ComputingElement selectCE(ArrayList ces, Job job) {

	ArrayList selectedCEs = new ArrayList();
	ComputingElement ce = null;
	int price = Integer.MAX_VALUE;

	for (int i = 0; i < ces.size(); i++) {

	    ce = (ComputingElement)ces.get(i);

	    if ( price > ce.getPA().getPrice(ce.getId()) ) {
		// found a cheeper resource:
		selectedCEs.clear();
		price = ce.getPA().getPrice(ce.getId());
		selectedCEs.add(ce);
	    }
	    else if ( price == ce.getPA().getPrice(ce.getId()) ) {
		// found a CE with the same cheap price:
		selectedCEs.add(ce);
	    }
	}

	if (selectedCEs.size() < 1) {
	    return null; // no CE found
	}

	// if we found at least one CE
	int ranIndex = (int) (((double)Math.random())*selectedCEs.size());
	return (ComputingElement) selectedCEs.get(ranIndex);
    }

}
