package org.edg.wl.dgas.dgassim.workload.rb;

import java.util.*;
import org.edg.wl.dgas.dgassim.*;
import org.edg.wl.dgas.dgassim.monitor.*;
import org.edg.wl.dgas.dgassim.fabric.*;

public class ResourceBroker {

    private boolean verbose;
    private boolean debug;

    private GIS gis;

    private static Matchmaker matchmaker;

    private UtilityModule utmod;

    public ResourceBroker(GIS gis, UtilityModule utm, boolean verbose,
			  boolean debug) {

	this.gis = gis;

	matchmaker = new Matchmaker(gis);
	utmod = utm;

	this.verbose = verbose;
	this.debug = debug;

	if (debug)
	    System.out.println("constructor of class ResourceBroker");
    }

    public boolean submitJob(Job job) {
	ArrayList ces = gis.getCEList();

	ces = matchmaker.getMatchingCEList(ces, job);

	ComputingElement selectedCE = utmod.selectCE(ces, job);
	if (selectedCE != null) { // found a suitable resource
	    // feed job with price info (instead of PA database)
	    job.setJobPrice(selectedCE.getPrice());
	    // now submit job!
	    return selectedCE.queueJob(job);
	}

	return false; // no resource found
    }

}
